--- old/usr/src/uts/common/exec/elf/elf.c	Wed Oct  5 00:33:41 2016
+++ new/usr/src/uts/common/exec/elf/elf.c	Wed Oct  5 00:33:41 2016
@@ -529,12 +529,12 @@
 		 *	AT_BASE
 		 *	AT_FLAGS
 		 *	AT_PAGESZ
-		 *	AT_RANDOM	(added in stk_copyout)
+		 *	AT_RANDOM
 		 *	AT_SUN_AUXFLAGS
 		 *	AT_SUN_HWCAP
 		 *	AT_SUN_HWCAP2
-		 *	AT_SUN_PLATFORM	(added in stk_copyout)
-		 *	AT_SUN_EXECNAME	(added in stk_copyout)
+		 *	AT_SUN_PLATFORM (added in stk_copyout)
+		 *	AT_SUN_EXECNAME (added in stk_copyout)
 		 *	AT_NULL
 		 *
 		 * total == 10
@@ -643,8 +643,7 @@
 	aux = bigwad->elfargs;
 	/*
 	 * Move args to the user's stack.
-	 * This can fill in the AT_SUN_PLATFORM, AT_SUN_EXECNAME and AT_RANDOM
-	 * aux entries.
+	 * This can fill in the AT_SUN_PLATFORM and AT_SUN_EXECNAME aux entries.
 	 */
 	if ((error = exec_args(uap, args, idatap, (void **)&aux)) != 0) {
 		if (error == -1) {
@@ -885,8 +884,8 @@
 		int auxf = AF_SUN_HWCAPVERIFY;
 
 		/*
-		 * Note: AT_SUN_PLATFORM, AT_SUN_EXECNAME and AT_RANDOM were
-		 * filled in via exec_args()
+		 * Note: AT_SUN_PLATFORM and AT_RANDOM were filled in via
+		 * exec_args()
 		 */
 		ADDAUX(aux, AT_BASE, voffset)
 		ADDAUX(aux, AT_FLAGS, at_flags)
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/fs/dev/sdev_subr.c	Wed Oct  5 00:33:41 2016
+++ new/usr/src/uts/common/fs/dev/sdev_subr.c	Wed Oct  5 00:33:41 2016
@@ -150,6 +150,12 @@
 kmem_cache_t	*sdev_node_cache;	/* sdev_node cache */
 int		devtype;		/* fstype */
 
+/* static */
+static struct vnodeops *sdev_get_vop(struct sdev_node *);
+static void sdev_set_no_negcache(struct sdev_node *);
+static fs_operation_def_t *sdev_merge_vtab(const fs_operation_def_t []);
+static void sdev_free_vtab(fs_operation_def_t *);
+
 static void
 sdev_prof_free(struct sdev_node *dv)
 {
@@ -307,7 +313,6 @@
 	(void) snprintf(dv->sdev_path, len, "%s/%s", ddv->sdev_path, nm);
 	/* overwritten for VLNK nodes */
 	dv->sdev_symlink = NULL;
-	list_link_init(&dv->sdev_plist);
 
 	vp = SDEVTOV(dv);
 	vn_reinit(vp);
@@ -396,7 +401,6 @@
 	} else {
 		dv->sdev_nlink = 1;
 	}
-	sdev_plugin_nodeready(dv);
 
 	if (!(SDEV_IS_GLOBAL(dv))) {
 		dv->sdev_origin = (struct sdev_node *)args;
@@ -493,22 +497,37 @@
 	return (dv);
 }
 
-struct sdev_vop_table vtab[] = {
-	{ "pts", devpts_vnodeops_tbl, &devpts_vnodeops, devpts_validate,
+/* directory dependent vop table */
+struct sdev_vop_table {
+	char *vt_name;				/* subdirectory name */
+	const fs_operation_def_t *vt_service;	/* vnodeops table */
+	struct vnodeops *vt_vops;		/* constructed vop */
+	struct vnodeops **vt_global_vops;	/* global container for vop */
+	int (*vt_vtor)(struct sdev_node *);	/* validate sdev_node */
+	int vt_flags;
+};
+
+/*
+ * A nice improvement would be to provide a plug-in mechanism
+ * for this table instead of a const table.
+ */
+static struct sdev_vop_table vtab[] =
+{
+	{ "pts", devpts_vnodeops_tbl, NULL, &devpts_vnodeops, devpts_validate,
 	SDEV_DYNAMIC | SDEV_VTOR },
 
-	{ "vt", devvt_vnodeops_tbl, &devvt_vnodeops, devvt_validate,
+	{ "vt", devvt_vnodeops_tbl, NULL, &devvt_vnodeops, devvt_validate,
 	SDEV_DYNAMIC | SDEV_VTOR },
 
-	{ "zvol", devzvol_vnodeops_tbl, &devzvol_vnodeops,
+	{ "zvol", devzvol_vnodeops_tbl, NULL, &devzvol_vnodeops,
 	devzvol_validate, SDEV_ZONED | SDEV_DYNAMIC | SDEV_VTOR | SDEV_SUBDIR },
 
-	{ "zcons", NULL, NULL, NULL, SDEV_NO_NCACHE },
+	{ "zcons", NULL, NULL, NULL, NULL, SDEV_NO_NCACHE },
 
-	{ "net", devnet_vnodeops_tbl, &devnet_vnodeops, devnet_validate,
-	SDEV_DYNAMIC | SDEV_VTOR | SDEV_SUBDIR },
+	{ "net", devnet_vnodeops_tbl, NULL, &devnet_vnodeops, devnet_validate,
+	SDEV_DYNAMIC | SDEV_VTOR },
 
-	{ "ipnet", devipnet_vnodeops_tbl, &devipnet_vnodeops,
+	{ "ipnet", devipnet_vnodeops_tbl, NULL, &devipnet_vnodeops,
 	devipnet_validate, SDEV_DYNAMIC | SDEV_VTOR | SDEV_NO_NCACHE },
 
 	/*
@@ -523,16 +542,134 @@
 	 * preventing a mkdir.
 	 */
 
-	{ "lofi", NULL, NULL, NULL,
+	{ "lofi", NULL, NULL, NULL, NULL,
 	    SDEV_ZONED | SDEV_DYNAMIC | SDEV_PERSIST },
-	{ "rlofi", NULL, NULL, NULL,
+	{ "rlofi", NULL, NULL, NULL, NULL,
 	    SDEV_ZONED | SDEV_DYNAMIC | SDEV_PERSIST },
 
-	{ NULL, NULL, NULL, NULL, 0}
+	{ NULL, NULL, NULL, NULL, NULL, 0}
 };
 
+/*
+ * We need to match off of the sdev_path, not the sdev_name. We are only allowed
+ * to exist directly under /dev.
+ */
+struct sdev_vop_table *
+sdev_match(struct sdev_node *dv)
+{
+	int vlen;
+	int i;
+	const char *path;
 
+	if (strlen(dv->sdev_path) <= 5)
+		return (NULL);
+
+	if (strncmp(dv->sdev_path, "/dev/", 5) != 0)
+		return (NULL);
+	path = dv->sdev_path + 5;
+
+	for (i = 0; vtab[i].vt_name; i++) {
+		if (strcmp(vtab[i].vt_name, path) == 0)
+			return (&vtab[i]);
+		if (vtab[i].vt_flags & SDEV_SUBDIR) {
+			vlen = strlen(vtab[i].vt_name);
+			if ((strncmp(vtab[i].vt_name, path,
+			    vlen - 1) == 0) && path[vlen] == '/')
+				return (&vtab[i]);
+		}
+
+	}
+	return (NULL);
+}
+
 /*
+ *  sets a directory's vnodeops if the directory is in the vtab;
+ */
+static struct vnodeops *
+sdev_get_vop(struct sdev_node *dv)
+{
+	struct sdev_vop_table *vtp;
+	char *path;
+
+	path = dv->sdev_path;
+	ASSERT(path);
+
+	/* gets the relative path to /dev/ */
+	path += 5;
+
+	/* gets the vtab entry it matches */
+	if ((vtp = sdev_match(dv)) != NULL) {
+		dv->sdev_flags |= vtp->vt_flags;
+		if (SDEV_IS_PERSIST(dv->sdev_dotdot) &&
+		    (SDEV_IS_PERSIST(dv) || !SDEV_IS_DYNAMIC(dv)))
+			dv->sdev_flags |= SDEV_PERSIST;
+
+		if (vtp->vt_vops) {
+			if (vtp->vt_global_vops)
+				*(vtp->vt_global_vops) = vtp->vt_vops;
+
+			return (vtp->vt_vops);
+		}
+
+		if (vtp->vt_service) {
+			fs_operation_def_t *templ;
+			templ = sdev_merge_vtab(vtp->vt_service);
+			if (vn_make_ops(vtp->vt_name,
+			    (const fs_operation_def_t *)templ,
+			    &vtp->vt_vops) != 0) {
+				cmn_err(CE_PANIC, "%s: malformed vnode ops\n",
+				    vtp->vt_name);
+				/*NOTREACHED*/
+			}
+			if (vtp->vt_global_vops) {
+				*(vtp->vt_global_vops) = vtp->vt_vops;
+			}
+			sdev_free_vtab(templ);
+
+			return (vtp->vt_vops);
+		}
+
+		return (sdev_vnodeops);
+	}
+
+	/* child inherits the persistence of the parent */
+	if (SDEV_IS_PERSIST(dv->sdev_dotdot))
+		dv->sdev_flags |= SDEV_PERSIST;
+
+	return (sdev_vnodeops);
+}
+
+static void
+sdev_set_no_negcache(struct sdev_node *dv)
+{
+	int i;
+	char *path;
+
+	ASSERT(dv->sdev_path);
+	path = dv->sdev_path + strlen("/dev/");
+
+	for (i = 0; vtab[i].vt_name; i++) {
+		if (strcmp(vtab[i].vt_name, path) == 0) {
+			if (vtab[i].vt_flags & SDEV_NO_NCACHE)
+				dv->sdev_flags |= SDEV_NO_NCACHE;
+			break;
+		}
+	}
+}
+
+void *
+sdev_get_vtor(struct sdev_node *dv)
+{
+	struct sdev_vop_table *vtp;
+
+	vtp = sdev_match(dv);
+	if (vtp)
+		return ((void *)vtp->vt_vtor);
+	else
+		return (NULL);
+}
+
+/*
  * Build the base root inode
  */
 ino_t
@@ -810,11 +947,8 @@
 		dv->sdev_path = NULL;
 	}
 
-	if (!SDEV_IS_GLOBAL(dv)) {
+	if (!SDEV_IS_GLOBAL(dv))
 		sdev_prof_free(dv);
-		if (dv->sdev_vnode->v_type != VLNK && dv->sdev_origin != NULL)
-			SDEV_RELE(dv->sdev_origin);
-	}
 
 	if (SDEVTOV(dv)->v_type == VDIR) {
 		ASSERT(SDEV_FIRST_ENTRY(dv) == NULL);
@@ -2811,6 +2945,46 @@
 	return (error);
 }
 
+extern int sdev_vnodeops_tbl_size;
+
+/*
+ * construct a new template with overrides from vtab
+ */
+static fs_operation_def_t *
+sdev_merge_vtab(const fs_operation_def_t tab[])
+{
+	fs_operation_def_t *new;
+	const fs_operation_def_t *tab_entry;
+
+	/* make a copy of standard vnode ops table */
+	new = kmem_alloc(sdev_vnodeops_tbl_size, KM_SLEEP);
+	bcopy((void *)sdev_vnodeops_tbl, new, sdev_vnodeops_tbl_size);
+
+	/* replace the overrides from tab */
+	for (tab_entry = tab; tab_entry->name != NULL; tab_entry++) {
+		fs_operation_def_t *std_entry = new;
+		while (std_entry->name) {
+			if (strcmp(tab_entry->name, std_entry->name) == 0) {
+				std_entry->func = tab_entry->func;
+				break;
+			}
+			std_entry++;
+		}
+		if (std_entry->name == NULL)
+			cmn_err(CE_NOTE, "sdev_merge_vtab: entry %s unused.",
+			    tab_entry->name);
+	}
+
+	return (new);
+}
+
+/* free memory allocated by sdev_merge_vtab */
+static void
+sdev_free_vtab(fs_operation_def_t *new)
+{
+	kmem_free(new, sdev_vnodeops_tbl_size);
+}
+
 /*
  * a generic setattr() function
  *
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/fs/lookup.c	Wed Oct  5 00:33:41 2016
+++ new/usr/src/uts/common/fs/lookup.c	Wed Oct  5 00:33:41 2016
@@ -21,7 +21,7 @@
 
 /*
  * Copyright 2015 Nexenta Systems, Inc.  All rights reserved.
- * Copyright 2016 Joyent, Inc.
+ * Copyright (c) 2015, Joyent, Inc. All rights reserved.
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
  */
 
@@ -979,109 +979,6 @@
 }
 
 /*
- * Clean a stale v_path from a vnode.  This is only performed if the v_path has
- * not been altered since it was found to be stale
- */
-static void
-vnode_clear_vpath(vnode_t *vp, char *vpath_old)
-{
-	mutex_enter(&vp->v_lock);
-	if (vp->v_path != vn_vpath_empty && vp->v_path == vpath_old) {
-		vp->v_path = vn_vpath_empty;
-		mutex_exit(&vp->v_lock);
-		kmem_free(vpath_old, strlen(vpath_old) + 1);
-	} else {
-		mutex_exit(&vp->v_lock);
-	}
-}
-
-/*
- * Validate that a pathname refers to a given vnode.
- */
-static int
-vnode_valid_pn(vnode_t *vp, vnode_t *vrootp, pathname_t *pn, pathname_t *rpn,
-    int flags, cred_t *cr)
-{
-	vnode_t *compvp;
-	/*
-	 * If we are in a zone or a chroot environment, then we have to
-	 * take additional steps, since the path to the root might not
-	 * be readable with the current credentials, even though the
-	 * process can legitmately access the file.  In this case, we
-	 * do the following:
-	 *
-	 * lookuppnvp() with all privileges to get the resolved path.
-	 * call localpath() to get the local portion of the path, and
-	 * continue as normal.
-	 *
-	 * If the the conversion to a local path fails, then we continue
-	 * as normal.  This is a heuristic to make process object file
-	 * paths available from within a zone.  Because lofs doesn't
-	 * support page operations, the vnode stored in the seg_t is
-	 * actually the underlying real vnode, not the lofs node itself.
-	 * Most of the time, the lofs path is the same as the underlying
-	 * vnode (for example, /usr/lib/libc.so.1).
-	 */
-	if (vrootp != rootdir) {
-		char *local = NULL;
-
-		VN_HOLD(rootdir);
-		if (lookuppnvp(pn, rpn, FOLLOW, NULL, &compvp, rootdir,
-		    rootdir, kcred) == 0) {
-			local = localpath(rpn->pn_path, vrootp, kcred);
-			VN_RELE(compvp);
-		}
-
-		/*
-		 * The original pn was changed through lookuppnvp().
-		 * Set it to local for next validation attempt.
-		 */
-		if (local) {
-			(void) pn_set(pn, local);
-		} else {
-			return (1);
-		}
-	}
-
-	/*
-	 * We should have a local path at this point, so start the search from
-	 * the root of the current process.
-	 */
-	VN_HOLD(vrootp);
-	if (vrootp != rootdir)
-		VN_HOLD(vrootp);
-	if (lookuppnvp(pn, rpn, FOLLOW | flags, NULL, &compvp, vrootp, vrootp,
-	    cr) == 0) {
-		/*
-		 * Check to see if the returned vnode is the same as the one we
-		 * expect.
-		 */
-		if (vn_compare(vp, compvp) ||
-		    vnode_match(vp, compvp, cr)) {
-			VN_RELE(compvp);
-			return (0);
-		} else {
-			VN_RELE(compvp);
-		}
-	}
-
-	return (1);
-}
-
-/*
- * Struct for tracking vnodes with invalidated v_path entries during a
- * dirtopath reverse lookup.  By keepeing adequate state, those vnode can be
- * revisted to populate v_path.
- */
-struct dirpath_walk {
-	struct dirpath_walk	*dw_next;
-	vnode_t			*dw_vnode;
-	vnode_t			*dw_pvnode;
-	size_t			dw_len;
-	char			*dw_name;
-};
-
-/*
  * Given a directory, return the full, resolved path.  This looks up "..",
  * searches for the given vnode in the parent, appends the component, etc.  It
  * is used to implement vnodetopath() and getcwd() when the cached path fails.
@@ -1090,14 +987,16 @@
 dirtopath(vnode_t *vrootp, vnode_t *vp, char *buf, size_t buflen, int flags,
     cred_t *cr)
 {
-	pathname_t	pn, rpn, emptypn;
-	vnode_t		*pvp = NULL, *startvp = vp;
-	int		err = 0;
-	size_t		complen;
-	dirent64_t	*dp;
-	char		*bufloc, *dbuf;
-	const size_t	dlen = DIRENT64_RECLEN(MAXPATHLEN);
-	struct dirpath_walk *dw_chain = NULL, *dw_entry;
+	pathname_t pn, rpn, emptypn;
+	vnode_t *cmpvp, *pvp = NULL;
+	vnode_t *startvp = vp;
+	int err = 0, vprivs;
+	size_t complen;
+	char *dbuf;
+	dirent64_t *dp;
+	char		*bufloc;
+	size_t		dlen = DIRENT64_RECLEN(MAXPATHLEN);
+	refstr_t	*mntpt;
 
 	/* Operation only allowed on directories */
 	ASSERT(vp->v_type == VDIR);
@@ -1122,9 +1021,6 @@
 	VN_HOLD(vp);
 
 	for (;;) {
-		int vprivs;
-		hrtime_t cached_stamp;
-
 		/*
 		 * Return if we've reached the root.  If the buffer is empty,
 		 * return '/'.  We explicitly don't use vn_compare(), since it
@@ -1149,33 +1045,85 @@
 		}
 
 		/*
+		 * Shortcut: see if this vnode is a mountpoint.  If so,
+		 * grab the path information from the vfs_t.
+		 */
+		if (vp->v_flag & VROOT) {
+
+			mntpt = vfs_getmntpoint(vp->v_vfsp);
+			if ((err = pn_set(&pn, (char *)refstr_value(mntpt)))
+			    == 0) {
+				refstr_rele(mntpt);
+				rpn.pn_path = rpn.pn_buf;
+
+				/*
+				 * Ensure the mountpoint still exists.
+				 */
+				VN_HOLD(vrootp);
+				if (vrootp != rootdir)
+					VN_HOLD(vrootp);
+				if (lookuppnvp(&pn, &rpn, flags, NULL,
+				    &cmpvp, vrootp, vrootp, cr) == 0) {
+
+					if (VN_CMP(vp, cmpvp)) {
+						VN_RELE(cmpvp);
+
+						complen = strlen(rpn.pn_path);
+						bufloc -= complen;
+						if (bufloc < buf) {
+							err = ERANGE;
+							goto out;
+						}
+						bcopy(rpn.pn_path, bufloc,
+						    complen);
+						break;
+					} else {
+						VN_RELE(cmpvp);
+					}
+				}
+			} else {
+				refstr_rele(mntpt);
+			}
+		}
+
+		/*
 		 * Shortcut: see if this vnode has correct v_path. If so,
 		 * we have the work done.
 		 */
 		mutex_enter(&vp->v_lock);
-		if (vp->v_path != vn_vpath_empty &&
-		    pn_set(&pn, vp->v_path) == 0) {
-			cached_stamp = vp->v_path_stamp;
-			mutex_exit(&vp->v_lock);
-			rpn.pn_path = rpn.pn_buf;
+		if (vp->v_path != NULL) {
 
-			/* Ensure the v_path pointing to correct vnode */
-			if (vnode_valid_pn(vp, vrootp, &pn, &rpn, flags,
-			    cr) == 0) {
-				complen = strlen(rpn.pn_path);
-				bufloc -= complen;
-				if (bufloc < buf) {
-					err = ERANGE;
-					goto out;
-				}
-				bcopy(rpn.pn_path, bufloc, complen);
-				break;
-			} else {
+			if ((err = pn_set(&pn, vp->v_path)) == 0) {
+				mutex_exit(&vp->v_lock);
+				rpn.pn_path = rpn.pn_buf;
+
 				/*
-				 * Immediately nuke cached v_path entries known
-				 * to be invalid.
+				 * Ensure the v_path pointing to correct vnode
 				 */
-				vn_clearpath(vp, cached_stamp);
+				VN_HOLD(vrootp);
+				if (vrootp != rootdir)
+					VN_HOLD(vrootp);
+				if (lookuppnvp(&pn, &rpn, flags, NULL,
+				    &cmpvp, vrootp, vrootp, cr) == 0) {
+
+					if (VN_CMP(vp, cmpvp)) {
+						VN_RELE(cmpvp);
+
+						complen = strlen(rpn.pn_path);
+						bufloc -= complen;
+						if (bufloc < buf) {
+							err = ERANGE;
+							goto out;
+						}
+						bcopy(rpn.pn_path, bufloc,
+						    complen);
+						break;
+					} else {
+						VN_RELE(cmpvp);
+					}
+				}
+			} else {
+				mutex_exit(&vp->v_lock);
 			}
 		} else {
 			mutex_exit(&vp->v_lock);
@@ -1220,6 +1168,38 @@
 		}
 
 		/*
+		 * Try to obtain the path component from dnlc cache
+		 * before searching through the directory.
+		 */
+		if ((cmpvp = dnlc_reverse_lookup(vp, dbuf, dlen)) != NULL) {
+			/*
+			 * If we got parent vnode as a result,
+			 * then the answered path is correct.
+			 */
+			if (VN_CMP(cmpvp, pvp)) {
+				VN_RELE(cmpvp);
+				complen = strlen(dbuf);
+				bufloc -= complen;
+				if (bufloc <= buf) {
+					err = ENAMETOOLONG;
+					goto out;
+				}
+				bcopy(dbuf, bufloc, complen);
+
+				/* Prepend a slash to the current path */
+				*--bufloc = '/';
+
+				/* And continue with the next component */
+				VN_RELE(vp);
+				vp = pvp;
+				pvp = NULL;
+				continue;
+			} else {
+				VN_RELE(cmpvp);
+			}
+		}
+
+		/*
 		 * Search the parent directory for the entry corresponding to
 		 * this vnode.
 		 */
@@ -1237,19 +1217,6 @@
 		/* Prepend a slash to the current path.  */
 		*--bufloc = '/';
 
-		/*
-		 * Record the name and directory for later reconstruction and
-		 * link it up with the others.
-		 */
-		dw_entry = kmem_alloc(sizeof (*dw_entry), KM_SLEEP);
-		dw_entry->dw_name = kmem_alloc(complen + 1, KM_SLEEP);
-		VN_HOLD(dw_entry->dw_vnode = vp);
-		VN_HOLD(dw_entry->dw_pvnode = pvp);
-		bcopy(dp->d_name, dw_entry->dw_name, complen + 1);
-		dw_entry->dw_len = complen;
-		dw_entry->dw_next = dw_chain;
-		dw_chain = dw_entry;
-
 		/* And continue with the next component */
 		VN_RELE(vp);
 		vp = pvp;
@@ -1264,37 +1231,6 @@
 
 out:
 	/*
-	 * Walk over encountered directory entries which were afflicted with a
-	 * stale or absent v_path.  If the dirtopath was successful, we should
-	 * possess the necessary information to populate all of them with a
-	 * valid v_path.
-	 *
-	 * While processing this list, it is safe to call vn_setpath despite
-	 * the fact that racing vnode actions may have altered v_path entries
-	 * while the above loopwas still executing.  Any updated entries will
-	 * have a newer v_path_stamp value which prevents an invalid overwrite.
-	 *
-	 * If an error was encountered during the search, freeing the chain is
-	 * still required.
-	 */
-	dw_entry = dw_chain;
-	while (dw_entry != NULL) {
-		struct dirpath_walk *next = dw_entry->dw_next;
-
-		if (err == 0) {
-			vn_setpath(NULL, dw_entry->dw_pvnode,
-			    dw_entry->dw_vnode, dw_entry->dw_name,
-			    dw_entry->dw_len);
-		}
-
-		VN_RELE(dw_entry->dw_vnode);
-		VN_RELE(dw_entry->dw_pvnode);
-		kmem_free(dw_entry->dw_name, dw_entry->dw_len + 1);
-		kmem_free(dw_entry, sizeof (*dw_entry));
-		dw_entry = next;
-	}
-
-	/*
 	 * If the error was ESTALE and the current directory to look in
 	 * was the root for this lookup, the root for a mounted file
 	 * system, or the starting directory for lookups, then
@@ -1334,10 +1270,12 @@
 vnodetopath_common(vnode_t *vrootp, vnode_t *vp, char *buf, size_t buflen,
     cred_t *cr, int flags)
 {
-	pathname_t pn;
-	int ret = 0;
-	vnode_t *realvp;
-	boolean_t doclose = B_FALSE;
+	pathname_t pn, rpn;
+	int ret, len;
+	vnode_t *compvp, *pvp, *realvp;
+	proc_t *p = curproc;
+	char path[MAXNAMELEN];
+	int doclose = 0;
 
 	/*
 	 * If vrootp is NULL, get the root for curproc.  Callers with any other
@@ -1344,8 +1282,6 @@
 	 * requirements should pass in a different vrootp.
 	 */
 	if (vrootp == NULL) {
-		proc_t *p = curproc;
-
 		mutex_enter(&p->p_lock);
 		if ((vrootp = PTOU(p)->u_rdir) == NULL)
 			vrootp = rootdir;
@@ -1367,59 +1303,163 @@
 	    realvp != vp) {
 		VN_HOLD(vp);
 		if (VOP_OPEN(&vp, FREAD, cr, NULL) == 0)
-			doclose = B_TRUE;
+			doclose = 1;
 		else
 			VN_RELE(vp);
 	}
 
+	pn_alloc(&pn);
+
 	/*
-	 * Check to see if we have a valid cached path in the vnode.
+	 * Check to see if we have a cached path in the vnode.
 	 */
-	pn_alloc(&pn);
 	mutex_enter(&vp->v_lock);
-	if (vp->v_path != vn_vpath_empty) {
-		hrtime_t cached_stamp;
-		pathname_t rpn;
-
-		cached_stamp = vp->v_path_stamp;
+	if (vp->v_path != NULL) {
 		(void) pn_set(&pn, vp->v_path);
 		mutex_exit(&vp->v_lock);
 
+		pn_alloc(&rpn);
+
 		/* We should only cache absolute paths */
 		ASSERT(pn.pn_buf[0] == '/');
 
-		pn_alloc(&rpn);
-		if (vnode_valid_pn(vp, vrootp, &pn, &rpn, flags, cr) == 0) {
-			/* Return the result, if we're able. */
-			if (buflen > rpn.pn_pathlen) {
-				bcopy(rpn.pn_path, buf, rpn.pn_pathlen + 1);
+		/*
+		 * If we are in a zone or a chroot environment, then we have to
+		 * take additional steps, since the path to the root might not
+		 * be readable with the current credentials, even though the
+		 * process can legitmately access the file.  In this case, we
+		 * do the following:
+		 *
+		 * lookuppnvp() with all privileges to get the resolved path.
+		 * call localpath() to get the local portion of the path, and
+		 * continue as normal.
+		 *
+		 * If the the conversion to a local path fails, then we continue
+		 * as normal.  This is a heuristic to make process object file
+		 * paths available from within a zone.  Because lofs doesn't
+		 * support page operations, the vnode stored in the seg_t is
+		 * actually the underlying real vnode, not the lofs node itself.
+		 * Most of the time, the lofs path is the same as the underlying
+		 * vnode (for example, /usr/lib/libc.so.1).
+		 */
+		if (vrootp != rootdir) {
+			char *local = NULL;
+			VN_HOLD(rootdir);
+			if (lookuppnvp(&pn, &rpn, FOLLOW,
+			    NULL, &compvp, rootdir, rootdir, kcred) == 0) {
+				local = localpath(rpn.pn_path, vrootp,
+				    kcred);
+				VN_RELE(compvp);
+			}
+
+			/*
+			 * The original pn was changed through lookuppnvp().
+			 * Set it to local for next validation attempt.
+			 */
+			if (local) {
+				(void) pn_set(&pn, local);
 			} else {
-				ret = ENAMETOOLONG;
+				goto notcached;
 			}
+		}
+
+		/*
+		 * We should have a local path at this point, so start the
+		 * search from the root of the current process.
+		 */
+		VN_HOLD(vrootp);
+		if (vrootp != rootdir)
+			VN_HOLD(vrootp);
+		ret = lookuppnvp(&pn, &rpn, FOLLOW | flags, NULL,
+		    &compvp, vrootp, vrootp, cr);
+		if (ret == 0) {
+			/*
+			 * Check to see if the returned vnode is the same as
+			 * the one we expect.  If not, give up.
+			 */
+			if (!vn_compare(vp, compvp) &&
+			    !vnode_match(vp, compvp, cr)) {
+				VN_RELE(compvp);
+				goto notcached;
+			}
+
+			VN_RELE(compvp);
+
+			/*
+			 * Return the result.
+			 */
+			if (buflen <= rpn.pn_pathlen)
+				goto notcached;
+
+			bcopy(rpn.pn_path, buf, rpn.pn_pathlen + 1);
 			pn_free(&pn);
 			pn_free(&rpn);
-			goto out;
+			VN_RELE(vrootp);
+			if (doclose) {
+				(void) VOP_CLOSE(vp, FREAD, 1, 0, cr, NULL);
+				VN_RELE(vp);
+			}
+			return (0);
 		}
+
+notcached:
 		pn_free(&rpn);
-		vn_clearpath(vp, cached_stamp);
 	} else {
 		mutex_exit(&vp->v_lock);
 	}
+
 	pn_free(&pn);
 
-	if (vp->v_type != VDIR) {
+	if (PROC_IS_BRANDED(curproc)) {
 		/*
-		 * The reverse lookup tricks used by dirtopath aren't possible
-		 * for non-directory entries.  The best which can be done is
-		 * clearing any stale v_path so later lookups can potentially
-		 * repopulate it with a valid path.
+		 * If v_path doesn't work out and we're in a branded zone,
+		 * we're not going to bother doing more work here:  because
+		 * directories from the global can be lofs mounted into odd
+		 * locations (e.g., /native in an lx zone), it is likely that
+		 * the DNLC reverse lookup will yield nothing.  Indeed, the
+		 * only certainty is that the DNLC reverse lookup will be
+		 * exceedingly painful; we save ourselves the substantial
+		 * grief of scanning the entire DNLC and kick out with ENOENT
+		 * in this case.
 		 */
 		ret = ENOENT;
-	} else {
+	} else if (vp->v_type != VDIR) {
+		/*
+		 * If we don't have a directory, try to find it in the dnlc via
+		 * reverse lookup.  Once this is found, we can use the regular
+		 * directory search to find the full path.
+		 */
+		if ((pvp = dnlc_reverse_lookup(vp, path, MAXNAMELEN)) != NULL) {
+			/*
+			 * Check if we have read privilege so, that
+			 * we can lookup the path in the directory
+			 */
+			ret = 0;
+			if ((flags & LOOKUP_CHECKREAD)) {
+				ret = VOP_ACCESS(pvp, VREAD, 0, cr, NULL);
+			}
+			if (ret == 0) {
+				ret = dirtopath(vrootp, pvp, buf, buflen,
+				    flags, cr);
+			}
+			if (ret == 0) {
+				len = strlen(buf);
+				if (len + strlen(path) + 1 >= buflen) {
+					ret = ENAMETOOLONG;
+				} else {
+					if (buf[len - 1] != '/')
+						buf[len++] = '/';
+					bcopy(path, buf + len,
+					    strlen(path) + 1);
+				}
+			}
+
+			VN_RELE(pvp);
+		} else
+			ret = ENOENT;
+	} else
 		ret = dirtopath(vrootp, vp, buf, buflen, flags, cr);
-	}
 
-out:
 	VN_RELE(vrootp);
 	if (doclose) {
 		(void) VOP_CLOSE(vp, FREAD, 1, 0, cr, NULL);
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/fs/sockfs/sockcommon_sops.c	Wed Oct  5 00:33:43 2016
+++ new/usr/src/uts/common/fs/sockfs/sockcommon_sops.c	Wed Oct  5 00:33:43 2016
@@ -24,7 +24,7 @@
  */
 
 /*
- * Copyright (c) 2015, Joyent, Inc.  All rights reserved.
+ * Copyright (c) 2014, Joyent, Inc.  All rights reserved.
  */
 
 #include <sys/types.h>
@@ -1324,26 +1324,6 @@
 		}
 	}
 
-	mutex_enter(&so->so_lock);
-	if (so->so_krecv_cb != NULL) {
-		boolean_t cont;
-		so_krecv_f func = so->so_krecv_cb;
-		void *arg = so->so_krecv_arg;
-
-		mutex_exit(&so->so_lock);
-		cont = func(so, mp, msg_size, flags & MSG_OOB, arg);
-		mutex_enter(&so->so_lock);
-		if (cont == B_TRUE) {
-			space_left = so->so_rcvbuf;
-		} else {
-			so->so_rcv_queued = so->so_rcvlowat;
-			*errorp = ENOSPC;
-			space_left = -1;
-		}
-		goto done_unlock;
-	}
-	mutex_exit(&so->so_lock);
-
 	if (flags & MSG_OOB) {
 		so_queue_oob(so, mp, msg_size);
 		mutex_enter(&so->so_lock);
@@ -1622,13 +1602,6 @@
 		return (ENOTCONN);
 	}
 
-	mutex_enter(&so->so_lock);
-	if (so->so_krecv_cb != NULL) {
-		mutex_exit(&so->so_lock);
-		return (EOPNOTSUPP);
-	}
-	mutex_exit(&so->so_lock);
-
 	if (msg->msg_flags & MSG_PEEK)
 		msg->msg_flags &= ~MSG_WAITALL;
 
--- old/usr/src/uts/common/fs/sockfs/sockcommon_subr.c	Wed Oct  5 00:33:43 2016
+++ new/usr/src/uts/common/fs/sockfs/sockcommon_subr.c	Wed Oct  5 00:33:43 2016
@@ -24,7 +24,6 @@
  */
 /*
  * Copyright 2014, OmniTI Computer Consulting, Inc. All rights reserved.
- * Copyright 2015 Joyent, Inc.
  */
 
 #include <sys/types.h>
@@ -2292,9 +2291,9 @@
 	fbfunc = sp->sp_smod_info->smod_proto_fallback_func;
 
 	/*
-	 * Cannot fallback if the socket has active filters or a krecv callback.
+	 * Cannot fallback if the socket has active filters
 	 */
-	if (so->so_filter_active > 0 || so->so_krecv_cb != NULL)
+	if (so->so_filter_active > 0)
 		return (EINVAL);
 
 	switch (so->so_family) {
@@ -2471,51 +2470,4 @@
 		freemsg(arg.soqa_urgmark_mp);
 
 	return (error);
-}
-
-int
-so_krecv_set(sonode_t *so, so_krecv_f cb, void *arg)
-{
-	int ret;
-
-	if (cb == NULL && arg != NULL)
-		return (EINVAL);
-
-	SO_BLOCK_FALLBACK(so, so_krecv_set(so, cb, arg));
-
-	mutex_enter(&so->so_lock);
-	if (so->so_state & SS_FALLBACK_COMP) {
-		mutex_exit(&so->so_lock);
-		SO_UNBLOCK_FALLBACK(so);
-		return (ENOTSUP);
-	}
-
-	ret = so_lock_read(so, 0);
-	VERIFY(ret == 0);
-	/*
-	 * Other consumers may actually care about getting extant data delivered
-	 * to them, when they come along, they should figure out the best API
-	 * for that.
-	 */
-	so_rcv_flush(so);
-
-	so->so_krecv_cb = cb;
-	so->so_krecv_arg = arg;
-
-	so_unlock_read(so);
-	mutex_exit(&so->so_lock);
-	SO_UNBLOCK_FALLBACK(so);
-
-	return (0);
-}
-
-void
-so_krecv_unblock(sonode_t *so)
-{
-	mutex_enter(&so->so_lock);
-	VERIFY(so->so_krecv_cb != NULL);
-
-	so->so_rcv_queued = 0;
-	(void) so_check_flow_control(so);
-	mutex_exit(&so->so_lock);
 }
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
